function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var TableContainer = _interopDefault(require('@material-ui/core/TableContainer'));
var Table = _interopDefault(require('@material-ui/core/Table'));
var TableBody = _interopDefault(require('@material-ui/core/TableBody'));
var TableCell = _interopDefault(require('@material-ui/core/TableCell'));
var TableRow = _interopDefault(require('@material-ui/core/TableRow'));
var Card = _interopDefault(require('@material-ui/core/Card'));
var Divider = _interopDefault(require('@material-ui/core/Divider'));
var styles = require('@material-ui/core/styles');
var TextField = _interopDefault(require('@material-ui/core/TextField'));
var Fab = _interopDefault(require('@material-ui/core/Fab'));
var DeleteIcon = _interopDefault(require('@material-ui/icons/Delete'));
var Autocomplete = _interopDefault(require('@material-ui/lab/Autocomplete'));
var ArrowDropUp = _interopDefault(require('@material-ui/icons/ArrowDropUp'));
var ArrowDropDown = _interopDefault(require('@material-ui/icons/ArrowDropDown'));
var Sort = _interopDefault(require('@material-ui/icons/Sort'));
var IconButton = _interopDefault(require('@material-ui/core/IconButton'));
var crypto = require('crypto');
var Button = _interopDefault(require('@material-ui/core/Button'));
var Chip = _interopDefault(require('@material-ui/core/Chip'));
var Menu = _interopDefault(require('@material-ui/core/Menu'));
var MenuItem = _interopDefault(require('@material-ui/core/MenuItem'));
var SaveIcon = _interopDefault(require('@material-ui/icons/Save'));
var AddIcon = _interopDefault(require('@material-ui/icons/Add'));
var ImportExportIcon = _interopDefault(require('@material-ui/icons/ImportExport'));
var SpeedDial = _interopDefault(require('@material-ui/lab/SpeedDial'));
var SpeedDialIcon = _interopDefault(require('@material-ui/lab/SpeedDialIcon'));
var SpeedDialAction = _interopDefault(require('@material-ui/lab/SpeedDialAction'));
var PictureAsPdfIcon = _interopDefault(require('@material-ui/icons/PictureAsPdf'));
var GridOnIcon = _interopDefault(require('@material-ui/icons/GridOn'));
var core = require('@material-ui/core');
var styled = _interopDefault(require('styled-components'));
var TableHead = _interopDefault(require('@material-ui/core/TableHead'));

var colWidth = {
  width: '4rem'
};

var includeProperty = function includeProperty(key, value, options) {
  if (value instanceof Object && !(value instanceof String || value instanceof Date)) {
    return false;
  }

  return !options.excludedFields || !options.excludedFields.includes(key);
};

var formatKey = function formatKey(key, options) {
  return options.capitalizeKeys === true ? key.charAt(0).toUpperCase() + key.slice(1) : key;
};

var formatValue = function formatValue(value) {
  if (isNaN(value) && !isNaN(Date.parse(value))) {
    return React.createElement(TableCell, null, new Date(value).toDateString());
  } else {
    return React.createElement(TableCell, null, value);
  }
};

var propertySheet = function propertySheet(object, options) {
  return object && Object.keys(object).map(function (key) {
    return includeProperty(key, object[key], options) && object.hasOwnProperty(key) && React.createElement(TableRow, null, React.createElement(TableCell, {
      style: colWidth
    }, formatKey(key, options)), React.createElement(TableCell, null, formatValue(object[key])));
  });
};
var arrayPropertySheet = function arrayPropertySheet(objectArray, options) {
  return objectArray && objectArray.map(function (object, index) {
    return React.createElement(React.Fragment, null, React.createElement(Card, null, React.createElement(Card, null, React.createElement(TableContainer, null, React.createElement(Table, {
      size: 'small'
    }, React.createElement(TableBody, null, propertySheet(object, options)))))), React.createElement(Divider, null));
  });
};
var objectPropertySheet = function objectPropertySheet(object, options) {
  return object && React.createElement(React.Fragment, null, React.createElement(Card, null, React.createElement(Card, null, React.createElement(TableContainer, null, React.createElement(Table, {
    size: 'small'
  }, React.createElement(TableBody, null, propertySheet(object, options)))))), React.createElement(Divider, null));
};

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _taggedTemplateLiteralLoose(strings, raw) {
  if (!raw) {
    raw = strings.slice(0);
  }

  strings.raw = raw;
  return strings;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _createForOfIteratorHelperLoose(o, allowArrayLike) {
  var it;

  if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) {
    if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
      if (it) o = it;
      var i = 0;
      return function () {
        if (i >= o.length) return {
          done: true
        };
        return {
          done: false,
          value: o[i++]
        };
      };
    }

    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  it = o[Symbol.iterator]();
  return it.next.bind(it);
}

var handleInputChange = function handleInputChange(stateHandler) {
  return function (event) {
    var _event$target = event.target,
        id = _event$target.id,
        value = _event$target.value;
    stateHandler(function (prevState) {
      var _extends2;

      return _extends({}, prevState, (_extends2 = {}, _extends2[id] = value, _extends2));
    });
  };
};
var handleInputChangeByIndex = function handleInputChangeByIndex(stateHandler, index) {
  return function (event) {
    var _event$target2 = event.target,
        id = _event$target2.id,
        value = _event$target2.value;
    stateHandler(function (prevState) {
      var array = [].concat(prevState);
      array[index][id] = value;
      return array;
    });
  };
};
var onMultiSelectAdd = function onMultiSelectAdd(options) {
  return function (list, value) {
    var state = options.state;
    var setState = options.setState;
    var fieldId = options.fieldId;
    var valueField = options.valueField;
    setState(function (prevState) {
      var _extends3;

      var existingValues = state[fieldId] ? state[fieldId] : [];
      existingValues.push(value[valueField]);
      return _extends({}, prevState, (_extends3 = {}, _extends3[fieldId] = existingValues, _extends3));
    });
  };
};
var onMultiSelectRemove = function onMultiSelectRemove(options) {
  return function (list, value) {
    var setState = options.setState;
    var fieldId = options.fieldId;
    var valueField = options.valueField;
    setState(function (prevState) {
      var _extends4;

      return _extends({}, prevState, (_extends4 = {}, _extends4[fieldId] = prevState[fieldId].filter(function (item) {
        return item != value[valueField];
      }), _extends4));
    });
  };
};
var onAutoCompleteInputChange = function onAutoCompleteInputChange(options) {
  return function (event, values) {
    var setState = options.setState;
    var fieldId = options.fieldId;
    setState(function (prevState) {
      var _extends5;

      return _extends({}, prevState, (_extends5 = {}, _extends5[fieldId] = values ? values : null, _extends5));
    });
  };
};

var useStyles = styles.makeStyles(function (theme) {
  return {
    alignItemsAndJustifyContent: {
      width: '100%',
      display: 'grid',
      alignItems: 'right',
      justifyContent: 'right'
    },
    hover: {},
    selected: {}
  };
});
var colWidth$1 = {
  width: '4rem'
};

var TextBox = function TextBox(props) {
  var _props$error, _props$error2, _props$error3;

  return React.createElement(TextField, {
    id: props.id,
    type: 'text',
    value: props.value,
    margin: 'dense',
    fullWidth: true,
    onChange: handleInputChange(props.setState),
    error: ((_props$error = props.error) === null || _props$error === void 0 ? void 0 : _props$error.constraints[props.id]) !== undefined,
    helperText: ((_props$error2 = props.error) === null || _props$error2 === void 0 ? void 0 : _props$error2.constraints[props.id]) !== undefined && ((_props$error3 = props.error) === null || _props$error3 === void 0 ? void 0 : _props$error3.constraints[props.id])
  });
};

var TextBoxArray = function TextBoxArray(props) {
  var _props$error4, _props$error5, _props$error6;

  return React.createElement(TextField, {
    id: props.id,
    type: 'text',
    value: props.value,
    margin: 'dense',
    fullWidth: true,
    onChange: handleInputChangeByIndex(props.setState, props.index),
    error: ((_props$error4 = props.error) === null || _props$error4 === void 0 ? void 0 : _props$error4.constraints[props.id]) !== undefined,
    helperText: ((_props$error5 = props.error) === null || _props$error5 === void 0 ? void 0 : _props$error5.constraints[props.id]) !== undefined && ((_props$error6 = props.error) === null || _props$error6 === void 0 ? void 0 : _props$error6.constraints[props.id])
  });
};

var includeProperty$1 = function includeProperty(key, value, options) {
  if (value instanceof Object && !(value instanceof String || value instanceof Date)) {
    return false;
  }

  return !options.excludedFields || !options.excludedFields.includes(key);
};

var formatKey$1 = function formatKey(key, options) {
  return options.capitalizeKeys === true ? key.charAt(0).toUpperCase() + key.slice(1) : key;
};

var formatValue$1 = function formatValue(key, value, options) {
  if (isNaN(value) && !isNaN(Date.parse(value))) {
    return React.createElement(TableCell, null, new Date(value).toDateString());
  } else {
    var _options$fieldCompone;

    var componentDef = (_options$fieldCompone = options.fieldComponents) === null || _options$fieldCompone === void 0 ? void 0 : _options$fieldCompone.filter(function (e) {
      return e.field === key;
    });

    if (componentDef && componentDef.length > 0) {
      return componentDef[0].componentType;
    } else {
      return React.createElement(TextBox, {
        id: key,
        value: value,
        label: formatKey$1(key, options),
        setState: options.setState,
        error: options.error
      });
    }
  }
};

var formatValueA = function formatValueA(key, value, options, index) {
  if (isNaN(value) && !isNaN(Date.parse(value))) {
    return React.createElement(TableCell, null, new Date(value).toDateString());
  } else {
    var _options$fieldCompone2;

    var componentDef = (_options$fieldCompone2 = options.fieldComponents) === null || _options$fieldCompone2 === void 0 ? void 0 : _options$fieldCompone2.filter(function (e) {
      return e.field === key;
    });

    if (componentDef && componentDef.length > 0) {
      return componentDef[0].componentType;
    } else {
      return React.createElement(TextBoxArray, {
        id: key,
        value: value,
        label: formatKey$1(key, options),
        setState: options.setState,
        index: index
      });
    }
  }
};

var EditablePropertySheet = function EditablePropertySheet(object, options) {
  return object && Object.keys(object).map(function (key) {
    return includeProperty$1(key, object[key], options) && object.hasOwnProperty(key) && React.createElement("span", null, React.createElement("div", null, ' ', React.createElement(TableRow, null, React.createElement(TableCell, {
      style: colWidth$1
    }, formatKey$1(key, options)), React.createElement(TableCell, null, formatValue$1(key, object[key], options)))));
  });
};
var editablePropertySheetArrayMember = function editablePropertySheetArrayMember(object, options, index) {
  return object && Object.keys(object).map(function (key) {
    return includeProperty$1(key, object[key], options) && object.hasOwnProperty(key) && React.createElement(TableRow, null, React.createElement(TableCell, {
      style: colWidth$1
    }, formatKey$1(key, options)), React.createElement(TableCell, null, formatValueA(key, object[key], options, index)));
  });
};
var EditableArrayPropertySheet = function EditableArrayPropertySheet(objectArray, options) {
  var classes = useStyles();
  return objectArray && objectArray.map(function (object, index) {
    return React.createElement(React.Fragment, null, React.createElement(Card, null, React.createElement(Card, null, React.createElement(TableContainer, null, React.createElement(Table, {
      size: 'small'
    }, React.createElement(TableBody, null, editablePropertySheetArrayMember(object, options, index)))), React.createElement("div", {
      className: classes.alignItemsAndJustifyContent
    }, React.createElement(Fab, {
      color: 'default',
      "aria-label": 'add',
      size: 'small'
    }, React.createElement(DeleteIcon, {
      onClick: function onClick(event) {
        options.setState(function (prevState) {
          return objectArray.filter(function (e) {
            return e != object;
          });
        });
      }
    }))))), React.createElement(Divider, null));
  });
};
var EditableObjectPropertySheet = function EditableObjectPropertySheet(object, options) {
  return object && React.createElement(React.Fragment, null, React.createElement(Card, null, React.createElement(Card, null, React.createElement(TableContainer, null, React.createElement(Table, {
    size: 'small'
  }, React.createElement(TableBody, null, EditablePropertySheet(object, options)))))), React.createElement(Divider, null));
};

var OrgDropdown = function OrgDropdown(props) {
  var onOrgAutoCompleteInputChange = function onOrgAutoCompleteInputChange(event, values) {
    props.setState(function (prevState) {
      return _extends({}, prevState, {
        _orgId: values ? values.data._id : null
      });
    });
  };

  return React__default.createElement(Autocomplete, {
    id: '_orgId',
    options: Array.from(props.orgs.mapData.values()),
    getOptionLabel: function getOptionLabel(option) {
      return option.data && option.data.name;
    },
    onChange: onOrgAutoCompleteInputChange,
    style: {
      width: 300
    },
    includeInputInList: true,
    renderInput: function renderInput(params) {
      return React__default.createElement(TextField, Object.assign({}, params, {
        label: "Organization: " + (props.orgs.mapData.get(props.state._orgId) ? props.orgs.mapData.get(props.state._orgId).data.name : ''),
        value: props.orgs.mapData.get(props.state._orgId)
      }));
    }
  });
};

var useSortableData = function useSortableData(items, config, containerName) {
  if (config === void 0) {
    config = {
      key: 'undefined',
      direction: 'undefined'
    };
  }

  if (containerName === void 0) {
    containerName = 'data';
  }

  var _React$useState = React.useState(config),
      sortConfig = _React$useState[0],
      setSortConfig = _React$useState[1];

  var sortedItems = React.useMemo(function () {
    var sortableItems = [].concat(items);

    if (sortConfig.key !== 'undefined') {
      sortableItems.sort(function (a, b) {
        var aValue = typeof a[containerName][sortConfig.key] == 'string' ? a[containerName][sortConfig.key].toLowerCase() : a[containerName][sortConfig.key];
        var bValue = typeof b[containerName][sortConfig.key] == 'string' ? b[containerName][sortConfig.key].toLowerCase() : b[containerName][sortConfig.key];

        if (aValue < bValue) {
          return sortConfig.direction === 'ascending' ? -1 : 1;
        }

        if (aValue > bValue) {
          return sortConfig.direction === 'ascending' ? 1 : -1;
        }

        return 0;
      });
    }

    return sortableItems;
  }, [items, sortConfig]);

  var requestSort = function requestSort(key) {
    var direction = 'ascending';

    if (sortConfig && sortConfig.key === key && sortConfig.direction === 'ascending') {
      direction = 'descending';
    }

    setSortConfig({
      key: key,
      direction: direction
    });
  };

  var getSortIcon = function getSortIcon(key) {
    if ((sortConfig === null || sortConfig === void 0 ? void 0 : sortConfig.key) === key) {
      return (sortConfig === null || sortConfig === void 0 ? void 0 : sortConfig.direction) === 'ascending' ? React.createElement(ArrowDropDown, null) : React.createElement(ArrowDropUp, null);
    }

    return React.createElement(Sort, null);
  };

  var SortableTableCell = function SortableTableCell(props) {
    return React.createElement(TableCell, {
      align: 'left'
    }, props.label, React.createElement(IconButton, {
      "aria-label": 'delete',
      color: 'primary',
      onClick: function onClick() {
        requestSort(props.column);
      }
    }, getSortIcon(props.column)));
  };

  return {
    items: sortedItems,
    requestSort: requestSort,
    getSortIcon: getSortIcon,
    SortableTableCell: SortableTableCell,
    sortConfig: sortConfig,
    containerName: containerName
  };
};

var useStandardDataEnrichment = function useStandardDataEnrichment(enrichableItems, orgsData, dataFieldName) {

  React.useMemo(function () {
    if (!orgsData) return;
    enrichableItems.forEach(function (item) {
      if (item === null || item === void 0 ? void 0 : item.data._orgId) {
        var _orgsData$mapData, _orgsData$mapData$get;

        var organization = item ? orgsData === null || orgsData === void 0 ? void 0 : (_orgsData$mapData = orgsData.mapData) === null || _orgsData$mapData === void 0 ? void 0 : (_orgsData$mapData$get = _orgsData$mapData.get(item.data._orgId)) === null || _orgsData$mapData$get === void 0 ? void 0 : _orgsData$mapData$get.data.name : '';
        var enrichedRating = item.data;
        enrichedRating.organization = organization;
      }
    });
  }, [enrichableItems, orgsData]);
  return {
    enrichableItems: enrichableItems,
    orgsData: orgsData
  };
};

// A type of promise-like that resolves synchronously and supports only one observer
const _Pact = /*#__PURE__*/(function() {
	function _Pact() {}
	_Pact.prototype.then = function(onFulfilled, onRejected) {
		const result = new _Pact();
		const state = this.s;
		if (state) {
			const callback = state & 1 ? onFulfilled : onRejected;
			if (callback) {
				try {
					_settle(result, 1, callback(this.v));
				} catch (e) {
					_settle(result, 2, e);
				}
				return result;
			} else {
				return this;
			}
		}
		this.o = function(_this) {
			try {
				const value = _this.v;
				if (_this.s & 1) {
					_settle(result, 1, onFulfilled ? onFulfilled(value) : value);
				} else if (onRejected) {
					_settle(result, 1, onRejected(value));
				} else {
					_settle(result, 2, value);
				}
			} catch (e) {
				_settle(result, 2, e);
			}
		};
		return result;
	};
	return _Pact;
})();

// Settles a pact synchronously
function _settle(pact, state, value) {
	if (!pact.s) {
		if (value instanceof _Pact) {
			if (value.s) {
				if (state & 1) {
					state = value.s;
				}
				value = value.v;
			} else {
				value.o = _settle.bind(null, pact, state);
				return;
			}
		}
		if (value && value.then) {
			value.then(_settle.bind(null, pact, state), _settle.bind(null, pact, 2));
			return;
		}
		pact.s = state;
		pact.v = value;
		const observer = pact.o;
		if (observer) {
			observer(pact);
		}
	}
}

const _iteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.iterator || (Symbol.iterator = Symbol("Symbol.iterator"))) : "@@iterator";

const _asyncIteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.asyncIterator || (Symbol.asyncIterator = Symbol("Symbol.asyncIterator"))) : "@@asyncIterator";

// Asynchronously implement a switch statement
function _switch(discriminant, cases) {
	var dispatchIndex = -1;
	var awaitBody;
	outer: {
		for (var i = 0; i < cases.length; i++) {
			var test = cases[i][0];
			if (test) {
				var testValue = test();
				if (testValue && testValue.then) {
					break outer;
				}
				if (testValue === discriminant) {
					dispatchIndex = i;
					break;
				}
			} else {
				// Found the default case, set it as the pending dispatch case
				dispatchIndex = i;
			}
		}
		if (dispatchIndex !== -1) {
			do {
				var body = cases[dispatchIndex][1];
				while (!body) {
					dispatchIndex++;
					body = cases[dispatchIndex][1];
				}
				var result = body();
				if (result && result.then) {
					awaitBody = true;
					break outer;
				}
				var fallthroughCheck = cases[dispatchIndex][2];
				dispatchIndex++;
			} while (fallthroughCheck && !fallthroughCheck());
			return result;
		}
	}
	const pact = new _Pact();
	const reject = _settle.bind(null, pact, 2);
	(awaitBody ? result.then(_resumeAfterBody) : testValue.then(_resumeAfterTest)).then(void 0, reject);
	return pact;
	function _resumeAfterTest(value) {
		for (;;) {
			if (value === discriminant) {
				dispatchIndex = i;
				break;
			}
			if (++i === cases.length) {
				if (dispatchIndex !== -1) {
					break;
				} else {
					_settle(pact, 1, result);
					return;
				}
			}
			test = cases[i][0];
			if (test) {
				value = test();
				if (value && value.then) {
					value.then(_resumeAfterTest).then(void 0, reject);
					return;
				}
			} else {
				dispatchIndex = i;
			}
		}
		do {
			var body = cases[dispatchIndex][1];
			while (!body) {
				dispatchIndex++;
				body = cases[dispatchIndex][1];
			}
			var result = body();
			if (result && result.then) {
				result.then(_resumeAfterBody).then(void 0, reject);
				return;
			}
			var fallthroughCheck = cases[dispatchIndex][2];
			dispatchIndex++;
		} while (fallthroughCheck && !fallthroughCheck());
		_settle(pact, 1, result);
	}
	function _resumeAfterBody(result) {
		for (;;) {
			var fallthroughCheck = cases[dispatchIndex][2];
			if (!fallthroughCheck || fallthroughCheck()) {
				break;
			}
			dispatchIndex++;
			var body = cases[dispatchIndex][1];
			while (!body) {
				dispatchIndex++;
				body = cases[dispatchIndex][1];
			}
			result = body();
			if (result && result.then) {
				result.then(_resumeAfterBody).then(void 0, reject);
				return;
			}
		}
		_settle(pact, 1, result);
	}
}

// Asynchronously call a function and send errors to recovery continuation
function _catch(body, recover) {
	try {
		var result = body();
	} catch(e) {
		return recover(e);
	}
	if (result && result.then) {
		return result.then(void 0, recover);
	}
	return result;
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var js_cookie = createCommonjsModule(function (module, exports) {
(function (factory) {
	var registeredInModuleLoader;
	{
		module.exports = factory();
		registeredInModuleLoader = true;
	}
	if (!registeredInModuleLoader) {
		var OldCookies = window.Cookies;
		var api = window.Cookies = factory();
		api.noConflict = function () {
			window.Cookies = OldCookies;
			return api;
		};
	}
}(function () {
	function extend () {
		var i = 0;
		var result = {};
		for (; i < arguments.length; i++) {
			var attributes = arguments[ i ];
			for (var key in attributes) {
				result[key] = attributes[key];
			}
		}
		return result;
	}

	function decode (s) {
		return s.replace(/(%[0-9A-Z]{2})+/g, decodeURIComponent);
	}

	function init (converter) {
		function api() {}

		function set (key, value, attributes) {
			if (typeof document === 'undefined') {
				return;
			}

			attributes = extend({
				path: '/'
			}, api.defaults, attributes);

			if (typeof attributes.expires === 'number') {
				attributes.expires = new Date(new Date() * 1 + attributes.expires * 864e+5);
			}

			// We're using "expires" because "max-age" is not supported by IE
			attributes.expires = attributes.expires ? attributes.expires.toUTCString() : '';

			try {
				var result = JSON.stringify(value);
				if (/^[\{\[]/.test(result)) {
					value = result;
				}
			} catch (e) {}

			value = converter.write ?
				converter.write(value, key) :
				encodeURIComponent(String(value))
					.replace(/%(23|24|26|2B|3A|3C|3E|3D|2F|3F|40|5B|5D|5E|60|7B|7D|7C)/g, decodeURIComponent);

			key = encodeURIComponent(String(key))
				.replace(/%(23|24|26|2B|5E|60|7C)/g, decodeURIComponent)
				.replace(/[\(\)]/g, escape);

			var stringifiedAttributes = '';
			for (var attributeName in attributes) {
				if (!attributes[attributeName]) {
					continue;
				}
				stringifiedAttributes += '; ' + attributeName;
				if (attributes[attributeName] === true) {
					continue;
				}

				// Considers RFC 6265 section 5.2:
				// ...
				// 3.  If the remaining unparsed-attributes contains a %x3B (";")
				//     character:
				// Consume the characters of the unparsed-attributes up to,
				// not including, the first %x3B (";") character.
				// ...
				stringifiedAttributes += '=' + attributes[attributeName].split(';')[0];
			}

			return (document.cookie = key + '=' + value + stringifiedAttributes);
		}

		function get (key, json) {
			if (typeof document === 'undefined') {
				return;
			}

			var jar = {};
			// To prevent the for loop in the first place assign an empty array
			// in case there are no cookies at all.
			var cookies = document.cookie ? document.cookie.split('; ') : [];
			var i = 0;

			for (; i < cookies.length; i++) {
				var parts = cookies[i].split('=');
				var cookie = parts.slice(1).join('=');

				if (!json && cookie.charAt(0) === '"') {
					cookie = cookie.slice(1, -1);
				}

				try {
					var name = decode(parts[0]);
					cookie = (converter.read || converter)(cookie, name) ||
						decode(cookie);

					if (json) {
						try {
							cookie = JSON.parse(cookie);
						} catch (e) {}
					}

					jar[name] = cookie;

					if (key === name) {
						break;
					}
				} catch (e) {}
			}

			return key ? jar[key] : jar;
		}

		api.set = set;
		api.get = function (key) {
			return get(key, false /* read as raw */);
		};
		api.getJSON = function (key) {
			return get(key, true /* read as json */);
		};
		api.remove = function (key, attributes) {
			set(key, '', extend(attributes, {
				expires: -1
			}));
		};

		api.defaults = {};

		api.withConverter = init;

		return api;
	}

	return init(function () {});
}));
});

var restFetch = function restFetch(url, options) {
  try {
    return Promise.resolve(_catch(function () {
      return Promise.resolve(fetch(url, options)).then(function (res) {
        if (res.ok) {
          return Promise.resolve(res.json());
        } else {
          throw res;
        }
      });
    }, function (error) {
      throw error;
    }));
  } catch (e) {
    return Promise.reject(e);
  }
};
var upsert = function upsert(url, data, apiVersion) {
  try {
    var random = Math.random().toString(16).substr(2, 6);
    var dateTimeBase64 = btoa(new Date().toISOString());
    var transactionId = dateTimeBase64 + random;
    var headers = {
      'Content-Type': 'application/json',
      Authorization: 'Bearer ' + js_cookie.get('token'),
      transaction_id: transactionId
    };

    if (apiVersion) {
      headers['accept-version'] = apiVersion;
    }

    return Promise.resolve(restFetch(url, {
      method: 'post',
      body: JSON.stringify(data),
      headers: headers
    }));
  } catch (e) {
    return Promise.reject(e);
  }
};
var get = function get(url, apiVersion) {
  try {
    var random = Math.random().toString(16).substr(2, 6);
    var dateTimeBase64 = btoa(new Date().toISOString());
    var transactionId = dateTimeBase64 + random;
    var headers = {
      'Content-Type': 'application/json',
      Authorization: 'Bearer ' + js_cookie.get('token'),
      transaction_id: transactionId
    };

    if (apiVersion) {
      headers['accept-version'] = apiVersion;
    }

    return Promise.resolve(restFetch(url, {
      method: 'get',
      headers: headers
    }));
  } catch (e) {
    return Promise.reject(e);
  }
};

var encrypt = function encrypt(text) {
  var key = crypto.createCipher('aes-128-cbc', ';#f`8O=?ovT`8!W4yK+g_r#[TA#K(5');
  var str = key.update(text, 'utf8', 'hex');
  return str + key["final"]('hex');
};
var decrypt = function decrypt(text) {
  console.log('decypting' + text);
  var key = crypto.createDecipher('aes-128-cbc', ';#f`8O=?ovT`8!W4yK+g_r#[TA#K(5');
  var str = key.update(text, 'hex', 'utf8');
  return str + key["final"]('utf8');
};

var makeClassValidationError = function makeClassValidationError(errors) {
  var constraints = {};
  var persistenceErrors = [];
  errors.forEach(function (error) {
    var _error$validationErro, _error$persistenceErr, _error$persistenceErr2;

    error === null || error === void 0 ? void 0 : (_error$validationErro = error.validationErrors) === null || _error$validationErro === void 0 ? void 0 : _error$validationErro.forEach(function (message) {
      for (var prop in message.constraints) {
        constraints[message.property] = message.constraints[prop];
      }
    });
    persistenceErrors.push((error === null || error === void 0 ? void 0 : (_error$persistenceErr = error.persistenceErrors) === null || _error$persistenceErr === void 0 ? void 0 : _error$persistenceErr.codeName) + " - " + (error === null || error === void 0 ? void 0 : (_error$persistenceErr2 = error.persistenceErrors) === null || _error$persistenceErr2 === void 0 ? void 0 : _error$persistenceErr2.keyValue.code));
  });
  return {
    hasError: true,
    constraints: constraints,
    message: "Form contains errors: " + persistenceErrors
  };
};
var makeError = function makeError(body) {
  var constraints = {};

  if (Array.isArray(body.message)) {
    for (var _iterator = _createForOfIteratorHelperLoose(body.message), _step; !(_step = _iterator()).done;) {
      var item = _step.value;
      var id = item.substr(0, item.indexOf(' '));
      constraints[id] = item;
    }

    return {
      hasError: true,
      constraints: constraints,
      message: 'Form contains field validation errors.'
    };
  } else {
    return {
      hasError: true,
      constraints: constraints,
      message: body.message ? body.message : 'System Error'
    };
  }
};

var doAnyPropsInclude = function doAnyPropsInclude(entity, value) {
  for (var prop in entity) {
    if (typeof entity[prop] === "string" && entity[prop].includes(value)) return true;
  }

  return false;
};

var WorkflowPanel = function WorkflowPanel(props) {
  var _useState = React.useState(props.data),
      entity = _useState[0],
      setEntity = _useState[1];

  var _useState2 = React.useState(props.label),
      label = _useState2[0],
      setLabel = _useState2[1];

  React.useEffect(function () {
    setEntity(props.data);
    setLabel(props.label);
  }, [props]);

  function handleClick(event, data) {
    var body = entity;
    fetch(window.location.origin + props.baseUrl + data.link, {
      method: 'post',
      body: JSON.stringify(body.data),
      headers: {
        'Content-Type': 'application/json',
        Authorization: 'Bearer ' + js_cookie.get('token')
      }
    }).then(function (response) {
      if (!response.ok) {
        console.log("Error:: " + response.statusText);
        throw response;
      }

      return response.json();
    }).then(function (data) {
      setEntity(data[0]);
      props.stateChangeHandler(data[0]);
      console.log('posted data');
    });

    if (data.formTrigger != undefined) {
      var action = {};
      action[data.formTrigger] = true;
      props.displayOptionChangeHandler(action);
    }
  }

  function makeButton(workflowStepName, value) {
    if (workflowStepName === 'download') {
      return React.createElement("a", {
        download: 'test.jpeg',
        href: window.location.origin + props.baseUrl + value.link + ("?jwt=" + js_cookie.get('token'))
      }, "DOWNLOAD");
    } else {
      return React.createElement(Button, {
        size: 'small',
        color: 'primary',
        onClick: function onClick(event) {
          return handleClick(event, value);
        }
      }, workflowStepName);
    }
  }

  function makePanel() {
    var panel = Array();

    if (entity && entity.workflow) {
      Object.entries(entity.workflow).forEach(function (_ref) {
        var key = _ref[0],
            value = _ref[1];
        return panel.push(makeButton(key, value));
      });
    }

    return panel;
  }

  return React.createElement("div", null, label != undefined && React.createElement(Chip, {
    label: label,
    color: 'primary'
  }), makePanel());
};

var ExportMenu = function ExportMenu(props) {
  var _React$useState = React__default.useState(null),
      anchorEl = _React$useState[0],
      setAnchorEl = _React$useState[1];

  var handleClick = function handleClick(event) {
    setAnchorEl(event.currentTarget);
  };

  var handleClose = function handleClose(exportFormat) {
    try {
      setAnchorEl(null);
      return Promise.resolve(get(props.url + "/" + exportFormat)).then(function () {});
    } catch (e) {
      return Promise.reject(e);
    }
  };

  return React__default.createElement("span", null, React__default.createElement(Button, {
    variant: 'contained',
    color: 'primary',
    endIcon: React__default.createElement(SaveIcon, null),
    onClick: handleClick
  }, "Export"), React__default.createElement(Menu, {
    id: 'simple-menu',
    anchorEl: anchorEl,
    keepMounted: true,
    open: Boolean(anchorEl),
    onClose: handleClose
  }, React__default.createElement(MenuItem, {
    onClick: function onClick() {
      return handleClose('pdf');
    }
  }, "PDF"), React__default.createElement(MenuItem, {
    onClick: function onClick() {
      return handleClose('excel');
    }
  }, "EXCEL")));
};

var CommonSpeedDial = function CommonSpeedDial(props) {
  var _React$useState = React.useState(false),
      open = _React$useState[0],
      setOpen = _React$useState[1];

  var _React$useState2 = React.useState(false),
      hidden = _React$useState2[0];

  var actions = [{
    icon: React.createElement(AddIcon, null),
    name: 'Create'
  }, {
    icon: React.createElement(ImportExportIcon, null),
    name: 'Import'
  }, {
    icon: React.createElement(PictureAsPdfIcon, null),
    name: 'Export Pdf'
  }, {
    icon: React.createElement(GridOnIcon, null),
    name: 'Export Excel'
  }];

  var handleClose = function handleClose(action) {
    try {
      setOpen(false);
      return Promise.resolve(_catch(function () {
        var _temp = _switch(action, [[function () {
          return 'Create';
        }, function () {
          props.setDisplayOptions({
            showEditForm: false,
            showAddForm: true
          });
        }], [function () {
          return 'Import';
        }, function () {
          props.setOpenImportDialog(true);
        }], [function () {
          return 'Export Pdf';
        }], [function () {
          return 'Export Excel';
        }, function () {
          return Promise.resolve(get(props.exportBaseUrl + "/" + action.replace('Export ', '').toLowerCase())).then(function () {});
        }], []]);

        if (_temp && _temp.then) return _temp.then(function () {});
      }, function () {}));
    } catch (e) {
      return Promise.reject(e);
    }
  };

  var handleOpen = function handleOpen() {
    setOpen(true);
  };

  return React.createElement(SpeedDial, {
    ariaLabel: 'SpeedDial',
    hidden: hidden,
    icon: React.createElement(SpeedDialIcon, null),
    onClose: handleClose,
    onOpen: handleOpen,
    open: open,
    direction: 'left'
  }, actions.map(function (action) {
    return React.createElement(SpeedDialAction, {
      key: action.name,
      icon: action.icon,
      tooltipTitle: action.name,
      onClick: function onClick() {
        return handleClose(action.name);
      }
    });
  }));
};

(function (EventNames) {
  EventNames["set"] = "set";
  EventNames["all"] = "all";
  EventNames["create"] = "create";
  EventNames["update"] = "update";
  EventNames["save"] = "save";
})(exports.EventNames || (exports.EventNames = {}));

var standardEvents = function standardEvents(namespace, socket, state, dispatch, dataFieldName) {
  if (dataFieldName === void 0) {
    dataFieldName = 'data';
  }

  socket.off('/error').on('/error', function (data) {
    console.log('ERROR' + JSON.stringify(data));
    console.log('Reconnecting...');
    socket.emit(namespace + "/authorize", {
      token: 'Bearer ' + js_cookie.get('token')
    });
  });
  socket.off("/" + exports.EventNames.update).on("/" + exports.EventNames.update, function (data) {
    console.log('EVENT/update: recieved');
    var dataMap = state.mapData;
    data.forEach(function (element) {
      dataMap.set(element[dataFieldName]._id, element);
    });
    dispatch({
      type: exports.EventNames.update,
      mapData: dataMap
    });
  });
  socket.off("/" + exports.EventNames.create).on("/" + exports.EventNames.create, function (data) {
    console.log('EVENT/create: recieved');
    var dataMap = state.mapData;
    data.forEach(function (element) {
      dataMap.set(element[dataFieldName]._id, element);
    });
    dispatch({
      type: exports.EventNames.create,
      mapData: dataMap
    });
  });
  socket.off("/" + exports.EventNames.all).on("/" + exports.EventNames.all, function (data) {
    console.log('EVENT/all: recieved');
    var dataMap = new Map(data.map(function (item) {
      return [item[dataFieldName]._id, item];
    }));
    dispatch({
      type: exports.EventNames.set,
      mapData: dataMap
    });
  });
  socket.off('/force-logout').on('/force-logout', function (tok) {
    console.log('EVENT/force-logout: recieved');

    if (js_cookie.get('token') === tok) {
      sessionStorage.removeItem('com.eldon.lewis.token');
    }
  });
};

var useStyles$1 = styles.makeStyles(function (theme) {
  return styles.createStyles({
    label: {
      flexDirection: 'column'
    },
    portalIcon: {
      '& svg': {
        fontSize: 150
      }
    }
  });
});
var PortalIcon = function PortalIcon(props) {
  var classes = useStyles$1();
  return React__default.createElement(core.IconButton, {
    href: props.href,
    classes: {
      root: classes.portalIcon,
      label: classes.label
    },
    color: props.color,
    component: props.component,
    to: props.to,
    onClick: props.onClick
  }, props.children);
};

function _templateObject6() {
  var data = _taggedTemplateLiteralLoose(["\n  width: 100%;\n  display: grid;\n  align-items: right;\n  justify-content: right;\n"]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = _taggedTemplateLiteralLoose(["\n  background-color: #007399;\n"]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = _taggedTemplateLiteralLoose(["\n  min-width: 100%;\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = _taggedTemplateLiteralLoose(["\n  max-height: 440;\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteralLoose(["\n  display: flex;\n  align-items: center;\n  justify-content: center;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteralLoose(["\n  padding-right: 0.625rem;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var ButtonContainer = styled.span(_templateObject());
var StyledCenteredDiv = styled.div(_templateObject2());
var StyledTableContainer = styled(TableContainer)(_templateObject3());
var StyledTable = styled(Table)(_templateObject4());
var StyledTableHead = styled(TableHead)(_templateObject5());
var StyledFabDiv = styled.div(_templateObject6());

var drawerWidth = 540;
var useTableStyles = styles.makeStyles(function (theme) {
  return {
    table: {
      minWidth: "100%"
    },
    tableHead: {
      backgroundColor: "#007399"
    },
    tableRow: {
      "&$selected, &$selected:hover": {
        backgroundColor: "#CCE1F0"
      }
    },
    container: {
      maxHeight: 440
    },
    drawerPaper: {
      width: drawerWidth
    },
    alignItemsAndJustifyContent: {
      width: "100%",
      display: "grid",
      alignItems: "right",
      justifyContent: "right"
    },
    hover: {},
    selected: {}
  };
});

exports.ButtonContainer = ButtonContainer;
exports.CommonSpeedDial = CommonSpeedDial;
exports.EditableArrayPropertySheet = EditableArrayPropertySheet;
exports.EditableObjectPropertySheet = EditableObjectPropertySheet;
exports.EditablePropertySheet = EditablePropertySheet;
exports.ExportMenu = ExportMenu;
exports.OrgDropdown = OrgDropdown;
exports.PortalIcon = PortalIcon;
exports.StyledCenteredDiv = StyledCenteredDiv;
exports.StyledFabDiv = StyledFabDiv;
exports.StyledTable = StyledTable;
exports.StyledTableContainer = StyledTableContainer;
exports.StyledTableHead = StyledTableHead;
exports.WorkflowPanel = WorkflowPanel;
exports.arrayPropertySheet = arrayPropertySheet;
exports.decrypt = decrypt;
exports.doAnyPropsInclude = doAnyPropsInclude;
exports.editablePropertySheetArrayMember = editablePropertySheetArrayMember;
exports.encrypt = encrypt;
exports.get = get;
exports.handleInputChange = handleInputChange;
exports.handleInputChangeByIndex = handleInputChangeByIndex;
exports.makeClassValidationError = makeClassValidationError;
exports.makeError = makeError;
exports.objectPropertySheet = objectPropertySheet;
exports.onAutoCompleteInputChange = onAutoCompleteInputChange;
exports.onMultiSelectAdd = onMultiSelectAdd;
exports.onMultiSelectRemove = onMultiSelectRemove;
exports.propertySheet = propertySheet;
exports.restFetch = restFetch;
exports.standardEvents = standardEvents;
exports.upsert = upsert;
exports.useSortableData = useSortableData;
exports.useStandardDataEnrichment = useStandardDataEnrichment;
exports.useTableStyles = useTableStyles;
//# sourceMappingURL=index.js.map
